]> git.ipfire.org Git - ipfire-2.x.git/blob - make.sh
deleted empty collectd rootfile
[ipfire-2.x.git] / make.sh
1 #!/bin/bash
2 ############################################################################
3 # #
4 # This file is part of the IPFire Firewall. #
5 # #
6 # IPFire is free software; you can redistribute it and/or modify #
7 # it under the terms of the GNU General Public License as published by #
8 # the Free Software Foundation; either version 2 of the License, or #
9 # (at your option) any later version. #
10 # #
11 # IPFire is distributed in the hope that it will be useful, #
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of #
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14 # GNU General Public License for more details. #
15 # #
16 # You should have received a copy of the GNU General Public License #
17 # along with IPFire; if not, write to the Free Software #
18 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19 # #
20 # Copyright (C) 2007 IPFire-Team <info@ipfire.org>. #
21 # #
22 ############################################################################
23 #
24
25 NAME="IPFire" # Software name
26 SNAME="ipfire" # Short name
27 VERSION="2.1" # Version number
28 SLOGAN="www.ipfire.org" # Software slogan
29 CONFIG_ROOT=/var/ipfire # Configuration rootdir
30 NICE=10 # Nice level
31 MAX_RETRIES=1 # prefetch/check loop
32 KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
33 MACHINE=`uname -m`
34 SVN_REVISION=`svn info | grep Revision | cut -c 11-`
35
36 IPFVER="full" # Which versions should be compiled? (full|devel)
37
38 # Debian specific settings
39 if [ ! -e /etc/debian_version ]; then
40 FULLPATH=`which $0`
41 else
42 if [ -x /usr/bin/realpath ]; then
43 FULLPATH=`/usr/bin/realpath $0`
44 else
45 echo "ERROR: Need to do apt-get install realpath"
46 exit 1
47 fi
48 fi
49
50 PWD=`pwd`
51 BASENAME=`basename $0`
52 BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
53 LOGFILE=$BASEDIR/log/_build.preparation.log
54 export BASEDIR LOGFILE
55 DIR_CHK=$BASEDIR/cache/check
56 mkdir $BASEDIR/log/ 2>/dev/null
57
58 # Include funtions
59 . tools/make-functions
60
61 if [ -f .config ]; then
62 . .config
63 else
64 echo -e "${BOLD}No configuration found!${NORMAL}"
65 echo -ne "Do you want to create one (y/N)?"
66 read CREATE_CONFIG
67 echo ""
68 if [ "$CREATE_CONFIG" == "y" ]; then
69 make_config
70 fi
71 fi
72
73 prepareenv() {
74 ############################################################################
75 # #
76 # Are we running the right shell? #
77 # #
78 ############################################################################
79 if [ ! "$BASH" ]; then
80 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
81 fi
82
83 if [ -z "${BASH_VERSION}" ]; then
84 exiterror "Not running BASH shell."
85 fi
86
87
88 ############################################################################
89 # #
90 # Trap on emergency exit #
91 # #
92 ############################################################################
93 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
94
95
96 ############################################################################
97 # #
98 # Resetting our nice level #
99 # #
100 ############################################################################
101 echo -ne "Resetting our nice level to $NICE" | tee -a $LOGFILE
102 renice $NICE $$ > /dev/null
103 if [ `nice` != "$NICE" ]; then
104 beautify message FAIL
105 exiterror "Failed to set correct nice level"
106 else
107 beautify message DONE
108 fi
109
110
111 ############################################################################
112 # #
113 # Checking if running as root user #
114 # #
115 ############################################################################
116 echo -ne "Checking if we're running as root user" | tee -a $LOGFILE
117 if [ `id -u` != 0 ]; then
118 beautify message FAIL
119 exiterror "Not building as root"
120 else
121 beautify message DONE
122 fi
123
124
125 ############################################################################
126 # #
127 # Checking for necessary temporary space #
128 # #
129 ############################################################################
130 echo -ne "Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
131 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
132 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
133 if (( 2048000 > $BASE_ASPACE )); then
134 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
135 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
136 beautify message FAIL
137 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
138 fi
139 else
140 beautify message DONE
141 fi
142
143 ############################################################################
144 # #
145 # Building Linux From Scratch system #
146 # #
147 ############################################################################
148 # Set umask
149 umask 022
150
151 # Set LFS Directory
152 LFS=$BASEDIR/build
153
154 # Check /tools symlink
155 if [ -h /tools ]; then
156 rm -f /tools
157 fi
158 if [ ! -a /tools ]; then
159 ln -s $BASEDIR/build/tools /
160 fi
161 if [ ! -h /tools ]; then
162 exiterror "Could not create /tools symbolic link."
163 fi
164
165 # Setup environment
166 set +h
167 LC_ALL=POSIX
168 MAKETUNING="-j6"
169 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
170 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
171
172 # Make some extra directories
173 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
174 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
175 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
176 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
177
178 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
179 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
180
181 # Make all sources and proc available under lfs build
182 mount --bind /dev $BASEDIR/build/dev
183 mount --bind /dev/pts $BASEDIR/build/dev/pts
184 mount --bind /dev/shm $BASEDIR/build/dev/shm
185 mount --bind /proc $BASEDIR/build/proc
186 mount --bind /sys $BASEDIR/build/sys
187 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
188 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
189 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
190 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
191 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
192 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
193 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
194 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
195 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
196
197 # This is a temporary hack!!!
198 if [ ! -f /tools/bin/hostname ]; then
199 cp -f /bin/hostname /tools/bin/hostname 2>/dev/null
200 fi
201
202 # Run LFS static binary creation scripts one by one
203 export CCACHE_DIR=$BASEDIR/ccache
204 export CCACHE_HASHDIR=1
205
206 # Remove pre-install list of installed files in case user erase some files before rebuild
207 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
208 }
209
210 buildtoolchain() {
211 LOGFILE="$BASEDIR/log/_build.toolchain.log"
212 export LOGFILE
213 ORG_PATH=$PATH
214 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
215 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
216 lfsmake1 ccache
217 lfsmake1 binutils PASS=1
218 lfsmake1 gcc PASS=1
219 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
220 lfsmake1 linux-libc-header
221 lfsmake1 glibc
222 lfsmake1 cleanup-toolchain PASS=1
223 lfsmake1 tcl
224 lfsmake1 expect
225 lfsmake1 dejagnu
226 lfsmake1 gcc PASS=2
227 lfsmake1 binutils PASS=2
228 lfsmake1 ncurses
229 lfsmake1 bash
230 lfsmake1 bzip2
231 lfsmake1 coreutils
232 lfsmake1 diffutils
233 lfsmake1 findutils
234 lfsmake1 gawk
235 lfsmake1 gettext
236 lfsmake1 grep
237 lfsmake1 gzip
238 lfsmake1 m4
239 lfsmake1 make
240 lfsmake1 patch
241 lfsmake1 perl
242 lfsmake1 sed
243 lfsmake1 tar
244 lfsmake1 texinfo
245 lfsmake1 util-linux
246 lfsmake1 cleanup-toolchain PASS=2
247 export PATH=$ORG_PATH
248 }
249
250 buildbase() {
251 LOGFILE="$BASEDIR/log/_build.base.log"
252 export LOGFILE
253 lfsmake2 stage2
254 lfsmake2 linux-libc-header
255 lfsmake2 man-pages
256 lfsmake2 glibc
257 lfsmake2 cleanup-toolchain PASS=3
258 lfsmake2 binutils
259 lfsmake2 gcc
260 lfsmake2 berkeley
261 lfsmake2 coreutils
262 lfsmake2 iana-etc
263 lfsmake2 m4
264 lfsmake2 bison
265 lfsmake2 ncurses
266 lfsmake2 procps
267 lfsmake2 sed
268 lfsmake2 libtool
269 lfsmake2 perl
270 lfsmake2 readline
271 lfsmake2 zlib
272 lfsmake2 autoconf
273 lfsmake2 automake
274 lfsmake2 bash
275 lfsmake2 bzip2
276 lfsmake2 diffutils
277 lfsmake2 e2fsprogs
278 lfsmake2 ed
279 lfsmake2 file
280 lfsmake2 findutils
281 lfsmake2 flex
282 lfsmake2 gawk
283 lfsmake2 gettext
284 lfsmake2 grep
285 lfsmake2 groff
286 lfsmake2 gzip
287 lfsmake2 inetutils
288 lfsmake2 iproute2
289 lfsmake2 kbd
290 lfsmake2 less
291 lfsmake2 libaal
292 lfsmake2 make
293 lfsmake2 man
294 lfsmake2 mktemp
295 lfsmake2 modutils
296 lfsmake2 mtd
297 lfsmake2 net-tools
298 lfsmake2 patch
299 lfsmake2 psmisc
300 lfsmake2 reiser4progs
301 lfsmake2 shadow
302 lfsmake2 sysklogd
303 lfsmake2 sysvinit
304 lfsmake2 tar
305 lfsmake2 texinfo
306 lfsmake2 udev
307 lfsmake2 util-linux
308 lfsmake2 vim
309 lfsmake2 grub
310 }
311
312 buildipfire() {
313 LOGFILE="$BASEDIR/log/_build.ipfire.log"
314 export LOGFILE
315 ipfiremake configroot
316 ipfiremake backup
317 ipfiremake dhcp
318 ipfiremake dhcpcd
319 ipfiremake libusb
320 ipfiremake libpcap
321 ipfiremake ppp
322 ipfiremake rp-pppoe
323 ipfiremake unzip
324 ipfiremake linux SMP=1
325 ipfiremake ipp2p SMP=1
326 ipfiremake zaptel SMP=1
327 ipfiremake r8169 SMP=1
328 ipfiremake r8168 SMP=1
329 ipfiremake mcs7830 SMP=1
330 ipfiremake atl1 SMP=1
331 ipfiremake kqemu SMP=1
332 ipfiremake linux
333 ipfiremake ipp2p
334 ipfiremake zaptel
335 ipfiremake r8169
336 ipfiremake r8168
337 ipfiremake mcs7830
338 ipfiremake atl1
339 ipfiremake kqemu
340 ipfiremake pkg-config
341 ipfiremake linux-atm
342 ipfiremake cpio
343 ipfiremake klibc
344 ipfiremake mkinitcpio
345 ipfiremake udev KLIBC=1
346 ipfiremake expat
347 ipfiremake gdbm
348 ipfiremake gmp
349 ipfiremake pam
350 ipfiremake openssl
351 ipfiremake curl
352 ipfiremake python
353 ipfiremake libnet
354 ipfiremake libidn
355 ipfiremake libjpeg
356 ipfiremake libpng
357 ipfiremake libtiff
358 ipfiremake libart
359 ipfiremake freetype
360 ipfiremake gd
361 ipfiremake popt
362 ipfiremake pcre
363 ipfiremake slang
364 ipfiremake newt
365 ipfiremake libcap
366 ipfiremake pciutils
367 ipfiremake usbutils
368 ipfiremake libxml2
369 ipfiremake libxslt
370 ipfiremake BerkeleyDB
371 ipfiremake mysql
372 ipfiremake cyrus-sasl
373 ipfiremake openldap
374 ipfiremake apache2
375 ipfiremake php
376 ipfiremake apache2 PASS=C
377 ipfiremake arping
378 ipfiremake beep
379 ipfiremake bind
380 ipfiremake cdrtools
381 ipfiremake dnsmasq
382 ipfiremake dosfstools
383 ipfiremake squashfstools
384 ipfiremake reiserfsprogs
385 ipfiremake xfsprogs
386 ipfiremake sysfsutils
387 ipfiremake fuse
388 ipfiremake ntfs-3g
389 ipfiremake ethtool
390 ipfiremake ez-ipupdate
391 ipfiremake fcron
392 ipfiremake perl-GD
393 ipfiremake GD-Graph
394 ipfiremake GD-TextUtil
395 ipfiremake gnupg
396 ipfiremake hdparm
397 ipfiremake sdparm
398 ipfiremake mtools
399 ipfiremake initscripts
400 ipfiremake whatmask
401 ipfiremake iptables
402 ipfiremake libupnp
403 ipfiremake ipp2p IPT=1
404 ipfiremake linux-igd
405 ipfiremake ipac-ng
406 ipfiremake ipaddr
407 ipfiremake iptstate
408 ipfiremake iputils
409 ipfiremake l7-protocols
410 ipfiremake mISDN
411 ipfiremake capi4k-utils
412 ipfiremake hwdata
413 ipfiremake kudzu
414 ipfiremake logrotate
415 ipfiremake logwatch
416 ipfiremake misc-progs
417 ipfiremake nano
418 ipfiremake nasm
419 ipfiremake URI
420 ipfiremake HTML-Tagset
421 ipfiremake HTML-Parser
422 ipfiremake Compress-Zlib
423 ipfiremake Digest
424 ipfiremake Digest-SHA1
425 ipfiremake Digest-HMAC
426 ipfiremake libwww-perl
427 ipfiremake Net-DNS
428 ipfiremake Net-IPv4Addr
429 ipfiremake Net_SSLeay
430 ipfiremake IO-Stringy
431 ipfiremake Unix-Syslog
432 ipfiremake Mail-Tools
433 ipfiremake MIME-Tools
434 ipfiremake Net-Server
435 ipfiremake Convert-TNEF
436 ipfiremake Convert-UUlib
437 ipfiremake Archive-Tar
438 ipfiremake Archive-Zip
439 ipfiremake Text-Tabs+Wrap
440 ipfiremake Locale-Country
441 ipfiremake XML-Parser
442 ipfiremake glib
443 ipfiremake GeoIP
444 ipfiremake fwhits
445 ipfiremake noip_updater
446 ipfiremake ntp
447 ipfiremake openssh
448 ipfiremake openswan
449 ipfiremake rrdtool
450 ipfiremake setserial
451 ipfiremake setup
452 ipfiremake snort
453 ipfiremake oinkmaster
454 ipfiremake squid
455 ipfiremake squid-graph
456 ipfiremake squidguard
457 ipfiremake calamaris
458 ipfiremake tcpdump
459 ipfiremake traceroute
460 ipfiremake vlan
461 ipfiremake wireless
462 ipfiremake libsafe
463 ipfiremake pakfire
464 ipfiremake java
465 ipfiremake spandsp
466 ipfiremake lzo
467 ipfiremake openvpn
468 ipfiremake pammysql
469 ipfiremake cups
470 ipfiremake ghostscript
471 ipfiremake foomatic
472 ipfiremake hplip
473 ipfiremake samba
474 ipfiremake sudo
475 ipfiremake mc
476 ipfiremake wget
477 ipfiremake bridge-utils
478 ipfiremake screen
479 ipfiremake hddtemp
480 ipfiremake smartmontools
481 ipfiremake htop
482 ipfiremake postfix
483 ipfiremake fetchmail
484 ipfiremake cyrus-imapd
485 ipfiremake openmailadmin
486 ipfiremake clamav
487 ipfiremake spamassassin
488 ipfiremake amavisd
489 ipfiremake alsa
490 ipfiremake mpg123
491 ipfiremake mpfire
492 ipfiremake guardian
493 ipfiremake libid3tag
494 ipfiremake libmad
495 ipfiremake libogg
496 ipfiremake libvorbis
497 ipfiremake lame
498 ipfiremake sox
499 ipfiremake libshout
500 ipfiremake icecast
501 ipfiremake icegenerator
502 ipfiremake mpd
503 ipfiremake mpc
504 ipfiremake xvid
505 ipfiremake libmpeg2
506 ipfiremake videolan
507 ipfiremake libpri
508 ipfiremake asterisk
509 ipfiremake gnump3d
510 ipfiremake libsigc++
511 ipfiremake applejuice
512 ipfiremake ocaml
513 ipfiremake mldonkey
514 ipfiremake libtorrent
515 ipfiremake rtorrent
516 ipfiremake ipfireseeder
517 ipfiremake rsync
518 ipfiremake tcpwrapper
519 ipfiremake portmap
520 ipfiremake nfs
521 ipfiremake nmap
522 ipfiremake mbmon
523 ipfiremake ncftp
524 ipfiremake etherwake
525 ipfiremake bwm-ng
526 ipfiremake tripwire
527 ipfiremake sysstat
528 ipfiremake vsftpd
529 ipfiremake which
530 ipfiremake lsof
531 ipfiremake centerim
532 ipfiremake br2684ctl
533 ipfiremake pcmciautils
534 ipfiremake collectd
535 ipfiremake lcd4linux
536 ipfiremake neon
537 ipfiremake subversion
538 ipfiremake tcptrack
539 ipfiremake teamspeak
540 ipfiremake elinks
541 ipfiremake igmpproxy
542 ipfiremake sdl
543 ipfiremake qemu
544 ipfiremake sane
545 ipfiremake netpbm
546 ipfiremake phpSANE
547 }
548
549 buildinstaller() {
550 # Run installer scripts one by one
551 LOGFILE="$BASEDIR/log/_build.installer.log"
552 export LOGFILE
553 ipfiremake syslinux
554 ipfiremake as86
555 ipfiremake mbr
556 ipfiremake memtest
557 installmake linux-libc-header
558 installmake binutils
559 ipfiremake uClibc PASS=1
560 ipfiremake gcc INST=1
561 installmake uClibc PASS=2
562 installmake gcc INST=2
563 installmake uClibc PASS=3
564 installmake busybox
565 installmake udev
566 installmake slang
567 installmake newt
568 installmake gettext
569 installmake kbd
570 installmake popt
571 installmake sysvinit
572 installmake misc-progs
573 installmake libaal
574 installmake reiser4progs
575 installmake reiserfsprogs
576 installmake sysfsutils
577 installmake util-linux
578 installmake pciutils
579 installmake zlib
580 installmake mtd
581 installmake wget
582 installmake hwdata
583 installmake kudzu
584 installmake pcmciautils
585 installmake installer
586 installmake initrd
587 }
588
589 buildpackages() {
590 LOGFILE="$BASEDIR/log/_build.packages.log"
591 export LOGFILE
592 echo "... see detailed log in _build.*.log files" >> $LOGFILE
593
594 installmake strip
595
596 # Generating list of packages used
597 echo -n "Generating packages list from logs" | tee -a $LOGFILE
598 rm -f $BASEDIR/doc/packages-list
599 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
600 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
601 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
602 fi
603 done
604 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
605 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
606 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
607 rm -f $BASEDIR/doc/packages-list
608 # packages-list.txt is ready to be displayed for wiki page
609 beautify message DONE
610
611 # Create images for install
612 ipfiremake cdrom ED=full
613
614 # Check if there is a loop device for building in virtual environments
615 if [ -e /dev/loop/0 ] || [ -e /dev/loop0 ]; then
616 ipfiremake usb-stick
617 fi
618 mv $LFS/install/images/{*.iso,*.tgz,*.img.gz} $BASEDIR >> $LOGFILE 2>&1
619
620 ipfirepackages
621
622 # Cleanup
623 stdumount
624 rm -rf $BASEDIR/build/tmp/*
625
626 # Generating total list of files
627 echo -n "Generating files list from logs" | tee -a $LOGFILE
628 rm -f $BASEDIR/log/FILES
629 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
630 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
631 echo "##" >>$BASEDIR/log/FILES
632 echo "## `basename $i`" >>$BASEDIR/log/FILES
633 echo "##" >>$BASEDIR/log/FILES
634 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
635 fi
636 done
637 beautify message DONE
638
639 cd $PWD
640 }
641
642 ipfirepackages() {
643 ipfiremake core-updates
644 for i in $(ls -1 $BASEDIR/config/rootfiles/packages); do
645 if [ -e $BASEDIR/lfs/$i ]; then
646 ipfiredist $i
647 else
648 echo -n $i
649 beautify message SKIP
650 fi
651 done
652 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
653 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
654 rm -rf $BASEDIR/build/install/packages/*
655 }
656
657 # See what we're supposed to do
658 case "$1" in
659 build)
660 clear
661 BUILDMACHINE=`uname -m`
662 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
663 #only restore on a clean disk
664 if [ ! -f log/cleanup-toolchain-2-tools ]; then
665 if [ ! -n "$PACKAGE" ]; then
666 beautify build_stage "Full toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
667 prepareenv
668 buildtoolchain
669 else
670 PACKAGENAME=${PACKAGE%.tar.gz}
671 beautify build_stage "Packaged toolchain compilation"
672 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
673 tar zxf $PACKAGE
674 prepareenv
675 else
676 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
677 fi
678 fi
679 else
680 echo -n "Using installed toolchain" | tee -a $LOGFILE
681 beautify message SKIP
682 prepareenv
683 fi
684
685 beautify build_start
686 beautify build_stage "Building LFS"
687 buildbase
688
689 beautify build_stage "Building IPFire"
690 buildipfire
691
692 # Setzen des IPFire Builds
693 if [ "$SVN_REVISION" ]; then
694 echo "$SVN_REVISION" > $BASEDIR/build/var/ipfire/firebuild
695 else
696 echo "_(OvO)_" > $BASEDIR/build/var/ipfire/firebuild
697 fi
698
699 beautify build_stage "Building installer"
700 buildinstaller
701
702 beautify build_stage "Building packages"
703 buildpackages
704 beautify build_end
705 ;;
706 shell)
707 # enter a shell inside LFS chroot
708 # may be used to changed kernel settings
709 prepareenv
710 entershell
711 ;;
712 changelog)
713 echo -n "Loading new Changelog from SVN: "
714 svn log http://svn.ipfire.org/svn/ipfire > doc/ChangeLog
715 beautify message DONE
716 ;;
717 clean)
718 echo -en "${BOLD}Cleaning build directory...${NORMAL}"
719 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
720 $LOSETUP -d $i 2>/dev/null
721 done
722 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
723 umount $i
724 done
725 stdumount
726 for i in `seq 0 7`; do
727 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
728 umount /dev/loop${i} 2>/dev/null;
729 losetup -d /dev/loop${i} 2>/dev/null;
730 fi;
731 done
732 rm -rf $BASEDIR/build
733 rm -rf $BASEDIR/cdrom
734 rm -rf $BASEDIR/packages
735 rm -rf $BASEDIR/log
736 if [ -h /tools ]; then
737 rm -f /tools
738 fi
739 beautify message DONE
740 ;;
741 downloadsrc)
742 if [ ! -d $BASEDIR/cache ]; then
743 mkdir $BASEDIR/cache
744 fi
745 mkdir -p $BASEDIR/log
746 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
747 FINISHED=0
748 cd $BASEDIR/lfs
749 for c in `seq $MAX_RETRIES`; do
750 if (( FINISHED==1 )); then
751 break
752 fi
753 FINISHED=1
754 cd $BASEDIR/lfs
755 for i in *; do
756 if [ -f "$i" -a "$i" != "Config" ]; then
757 echo -ne "Loading $i"
758 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
759 if [ $? -ne 0 ]; then
760 beautify message FAIL
761 FINISHED=0
762 else
763 if [ $c -eq 1 ]; then
764 beautify message DONE
765 fi
766 fi
767 fi
768 done
769 done
770 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
771 ERROR=0
772 for i in *; do
773 if [ -f "$i" -a "$i" != "Config" ]; then
774 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
775 if [ $? -ne 0 ]; then
776 echo -ne "MD5 difference in lfs/$i"
777 beautify message FAIL
778 ERROR=1
779 fi
780 fi
781 done
782 if [ $ERROR -eq 0 ]; then
783 echo -ne "${BOLD}all files md5sum match${NORMAL}"
784 beautify message DONE
785 else
786 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
787 beautify message FAIL
788 fi
789 cd - >/dev/null 2>&1
790 ;;
791 toolchain)
792 clear
793 prepareenv
794 beautify build_stage "Toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
795 buildtoolchain
796 BUILDMACHINE=`uname -m`
797 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
798 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
799 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
800 build/{bin,etc,usr/bin,usr/local} \
801 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
802 log >> $LOGFILE
803 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
804 > cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.md5
805 stdumount
806 ;;
807 gettoolchain)
808 BUILDMACHINE=`uname -m`
809 # arbitrary name to be updated in case of new toolchain package upload
810 PACKAGE=$SNAME-$VERSION-toolchain-$BUILDMACHINE
811 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
812 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
813 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
814 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
815 cd $BASEDIR/cache/toolchains
816 wget $URL_TOOLCHAIN/$PACKAGE.tar.gz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
817 if [ $? -ne 0 ]; then
818 echo "`date -u '+%b %e %T'`: error downloading toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
819 else
820 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
821 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
822 else
823 exiterror "$PACKAGE.md5 did not match, check downloaded package"
824 fi
825 fi
826 else
827 echo "Toolchain is already downloaded. Exiting..."
828 fi
829 ;;
830 othersrc)
831 prepareenv
832 echo -ne "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
833 chroot $LFS /tools/bin/env -i HOME=/root \
834 TERM=$TERM PS1='\u:\w\$ ' \
835 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
836 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
837 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
838 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
839 if [ $? -eq "0" ]; then
840 beautify message DONE
841 else
842 beautify message FAIL
843 fi
844 stdumount
845 ;;
846 svn)
847 case "$2" in
848 update|up)
849 # clear
850 echo -ne "Loading the latest source files...\n"
851 if [ $3 ]; then
852 svn update -r $3 | tee -a $PWD/log/_build.svn.update.log
853 else
854 svn update | tee -a $PWD/log/_build.svn.update.log
855 fi
856 if [ $? -eq "0" ]; then
857 beautify message DONE
858 else
859 beautify message FAIL
860 exit 1
861 fi
862 echo -ne "Writing the svn-info to a file"
863 svn info > $PWD/svn_status
864 if [ $? -eq "0" ]; then
865 beautify message DONE
866 else
867 beautify message FAIL
868 exit 1
869 fi
870 chmod 755 $0
871 exit 0
872 ;;
873 commit|ci)
874 clear
875 if [ -f /usr/bin/mcedit ]; then
876 export EDITOR=/usr/bin/mcedit
877 fi
878 if [ -f /usr/bin/nano ]; then
879 export EDITOR=/usr/bin/nano
880 fi
881 echo -ne "Selecting editor $EDITOR..."
882 beautify message DONE
883 if [ -e /sbin/yast ]; then
884 if [ "`echo $SVN_REVISION | cut -c 3`" -eq "0" ]; then
885 $0 changelog
886 fi
887 fi
888 update_langs
889 svn commit
890 $0 svn up
891 if [ -n "$FTP_CACHE_URL" ]; then
892 $0 uploadsrc
893 fi
894 ;;
895 dist)
896 if [ $3 ]; then
897 SVN_REVISION=$3
898 fi
899 if [ -f ipfire-source-r$SVN_REVISION.tar.gz ]; then
900 echo -ne "REV $SVN_REVISION: SKIPPED!\n"
901 exit 0
902 fi
903 echo -en "REV $SVN_REVISION: Downloading..."
904 svn export http://svn.ipfire.org/svn/ipfire/trunk ipfire-source/ --force > /dev/null
905 svn log http://svn.ipfire.org/svn/ipfire/trunk -r 1:$SVN_REVISION > ipfire-source/Changelog
906 #svn info http://svn.ipfire.org/svn/ipfire/trunk -r $SVN_REVISION > ipfire-source/svn_status
907 evaluate 1
908
909 echo -en "REV $SVN_REVISION: Compressing files..."
910 if [ -e ipfire-source/trunk/make.sh ]; then
911 chmod 755 ipfire-source/trunk/make.sh
912 fi
913 tar cfz ipfire-source-r$SVN_REVISION.tar.gz ipfire-source
914 evaluate 1
915 echo -en "REV $SVN_REVISION: Cleaning up..."
916 rm ipfire-source/ -r
917 evaluate 1
918 ;;
919 diff|di)
920 update_langs
921 echo -ne "Make a local diff to last svn revision"
922 svn diff > ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff
923 evaluate 1
924 echo "Diff was successfully saved to ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff"
925 svn status
926 ;;
927 esac
928 ;;
929 uploadsrc)
930 PWD=`pwd`
931 cd $BASEDIR/cache/
932 echo -e "Uploading cache to ftp server:"
933 ncftpls -u $FTP_CACHE_USER -p $FTP_CACHE_PASS ftp://$FTP_CACHE_URL/$FTP_CACHE_PATH/ > /tmp/ftplist
934 for i in *; do
935 if [ "$(basename $i)" == "toolchains" ]; then continue; fi
936 grep -q $(basename $i) /tmp/ftplist
937 if [ "$?" -ne "0" ]; then
938 echo -ne "$(basename $i)"
939 ncftpput -u $FTP_CACHE_USER -p $FTP_CACHE_PASS $FTP_CACHE_URL $FTP_CACHE_PATH/ $(basename $i)
940 if [ "$?" -ne "0" ]; then
941 beautify message FAIL
942 fi
943 fi
944 done
945 rm -f /tmp/ftplist
946 cd $PWD
947 exit 0
948 ;;
949 upload)
950 FTP_ISO_PORT=`echo "$FTP_ISO_URL" | awk -F: '{ print $2 }'`
951 FTP_ISO_URL=`echo "$FTP_ISO_URL" | awk -F: '{ print $1 }'`
952 if [ -z $FTP_ISO_PORT ]; then
953 FTP_ISO_PORT=21
954 fi
955 cat <<EOF > .ftp-commands
956 mkdir -p $FTP_ISO_PATH$SVN_REVISION
957 mkdir -p $FTP_ISO_PATH$SVN_REVISION/paks
958 quit
959 EOF
960 ncftp -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL < .ftp-commands
961 rm -f .ftp-commands
962
963 case "$2" in
964 iso)
965 echo -e "Uploading the iso to $FTP_ISO_PATH/$SVN_REVISION."
966
967 md5sum ipfire-$VERSION.$MACHINE-full.iso > ipfire-$VERSION.$MACHINE-full.iso.md5
968 for i in svn_status ipfire-source-r$SVN_REVISION.tar.gz ipfire-$VERSION.$MACHINE-full.iso ipfire-$VERSION.$MACHINE-full.iso.md5 ipfire-$VERSION.$MACHINE-devel.iso ipfire-$VERSION.$MACHINE-devel.iso.md5; do
969 if [ -e "$i" ]; then
970 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ $i
971 if [ "$?" -eq "0" ]; then
972 echo "The file with name $i was successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
973 else
974 echo "There was an error while uploading the file $i to the ftp server."
975 exit 1
976 fi
977 fi
978 done
979 rm -f ipfire-$VERSION.$MACHINE-full.iso.md5
980 if [ "$3" = "--with-sources-cd" ]; then
981 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH/$SVN_REVISION/ ipfire-sources-cd-$VERSION.$MACHINE.iso
982 fi
983 ;;
984 paks)
985 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/paks packages/*
986 if [ "$?" -eq "0" ]; then
987 echo -e "The packages were successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
988 else
989 echo -e "There was an error while uploading the packages to the ftp server."
990 exit 1
991 fi
992 ;;
993 esac
994 ;;
995 batch)
996 if [ "$2" = "--background" ]; then
997 batch_script
998 exit $?
999 fi
1000 if [ `screen -ls | grep -q ipfire` ]; then
1001 echo "Build is already running, sorry!"
1002 exit 1
1003 else
1004 if [ "$2" = "--rebuild" ]; then
1005 export IPFIRE_REBUILD=1
1006 echo "REBUILD!"
1007 else
1008 export IPFIRE_REBUILD=0
1009 fi
1010 echo -en "${BOLD}***IPFire-Batch-Build is starting...${NORMAL}"
1011 screen -dmS ipfire $0 batch --background
1012 evaluate 1
1013 exit 0
1014 fi
1015 ;;
1016 watch)
1017 watch_screen
1018 ;;
1019 pxe)
1020 case "$2" in
1021 start)
1022 start_tftpd
1023 ;;
1024 stop)
1025 stop_tftpd
1026 ;;
1027 reload|restart)
1028 reload_tftpd
1029 ;;
1030 esac
1031 exit 0
1032 ;;
1033 lang)
1034 update_langs
1035 ;;
1036 "")
1037 clear
1038 svn info
1039 select name in "Exit" "IPFIRE: Downloadsrc" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "SVN: Commit" "SVN: Update" "SVN: Status" "SVN: Diff" "LOG: Tail" "Help"
1040 do
1041 case $name in
1042 "IPFIRE: Downloadsrc")
1043 $0 downloadsrc
1044 ;;
1045 "IPFIRE: Build (silent)")
1046 $0 build-silent
1047 ;;
1048 "IPFIRE: Watch Build")
1049 $0 watch
1050 ;;
1051 "IPFIRE: Batch")
1052 $0 batch
1053 ;;
1054 "IPFIRE: Clean")
1055 $0 clean
1056 ;;
1057 "SVN: Update")
1058 $0 svn update
1059 ;;
1060 "Help")
1061 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1062 cat doc/make.sh-usage
1063 ;;
1064 "LOG: Tail")
1065 tail -f log/_*
1066 ;;
1067 "Exit")
1068 break
1069 ;;
1070 esac
1071 done
1072 ;;
1073 config)
1074 make_config
1075 ;;
1076 *)
1077 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1078 cat doc/make.sh-usage
1079 ;;
1080 esac